unit Bundeeventu;

interface

uses MainUnit, BundeCardClasses, Bundegui, StdCtrls, Graphics, Classes;

  procedure ProgInit;
  procedure NewGame;
  procedure ValgtKortNil;
  procedure MouseDown(Pile: TPile; Card: TCard);
  procedure MouseUp(Pile: TPile; Card: TCard);
  procedure FlytEs(S: Char; V: Integer);
  procedure FortrydEs(S: Char; V: Integer);


implementation

uses dialogs,sysutils, eventu;

type TSelection=class
                  private
                    MyPile: TPile;
                    MyCard: TCard;
                  public
                    constructor Create;
                    procedure SetPileAndCard(aPile: TPile; aCard: TCard);
                    function GetPile: TPile;
                    function GetCard: TCard;
                    procedure Clear;
                end;


var a, b, c, d, bunke : TPile;
    Selection: TSelection;
    ValgtKort : TCard;
    ValgtEs : TCard;

const
    KortAfstand : Integer = 21;

constructor TSelection.Create;
begin
  MyPile:=nil; MyCard:=nil;
end;

procedure TSelection.SetPileAndCard(aPile: TPile; aCard: TCard);
begin
  MyPile:=aPile;
  MyCard:=aCard;
end;

function  TSelection.GetPile: TPile;
begin
  Result:=MyPile;
end;

function  TSelection.GetCard: TCard;
begin
  Result:=MyCard;
end;

procedure TSelection.Clear;
begin
  MyPile:=nil; MyCard:=nil;
end;

procedure ProgInit;
{ Kaldes ved programstart;
  skriv evt. initialiseringer ved programstart i denne procedure }
var
  i : Integer;
begin
  BundeTiderForm.ClientWidth := KortAfstand * 12 + 77;
  for i := 1 to 4 do
  begin
    EsLabels[i] := TLabel.Create(BundeTiderForm);
    with EsLabels[i] do
    begin
      Name := 'EsLabel' + IntToStr(i);
      Left := 8 + (i - 1) * 80;
      Top := 8;
      Enabled := False;
      Caption := 'Es nr. ' + IntToStr(i);
    end;
    BundeTiderForm.InsertControl(EsLabels[i]);
    NavnLabels[i] := TLabel.Create(BundeTiderForm);
    with NavnLabels[i] do
    begin
      Name := 'NavnLabel' + IntToStr(i);
      Left := EsLabels[i].Left;
      Top := EsLabels[i].Top + 130;
      Enabled := False;
      Caption := 'Spiller:';
    end;
    BundeTiderForm.InsertControl(NavnLabels[i]);
    TidLabels[i] := TLabel.Create(BundeTiderForm);
    with TidLabels[i] do
    begin
      Name := 'TidLabel' + IntToStr(i);
      Left := EsLabels[i].Left;
      Top := EsLabels[i].Top + 130 + 40;
      Enabled := False;
      Caption := 'Tid:';
    end;
    BundeTiderForm.InsertControl(TidLabels[i]);
    BunderNavnEdits[i] := TEdit.Create(BundeTiderForm);
    with BunderNavnEdits[i] do
    begin
      Name := 'NavnEdit' + IntToStr(i);
      Left := NavnLabels[i].Left;
      Top := NavnLabels[i].Top + 16;
      Width := 68;  Height := 21;
      Text := '';
      ReadOnly := True;
      Color := clBtnFace;
      TabStop := False;
    end;
    BundeTiderForm.InsertControl(BunderNavnEdits[i]);
    TidEdits[i] := TEdit.Create(BundeTiderForm);
    with TidEdits[i] do
    begin
      Name := 'TidEdit' + IntToStr(i);
      Left := TidLabels[i].Left;
      Top := TidLabels[i].Top + 16;
      Width := 68;  Height := 21;
      Text := '';
      ReadOnly := True;
      Color := clBtnFace;
      TabStop := False;
    end;
    BundeTiderForm.InsertControl(TidEdits[i]);
    BundePlaceringLabels[i] := TLabel.Create(BundeTiderForm);
    with BundePlaceringLabels[i] do
    begin
      Name := 'BundePlaceringLabel' + IntToStr(i);
      Left := TidEdits[i].Left; Width := TidEdits[i].Width;
      Top := TidEdits[i].Top + 30; Height := 50;
      AutoSize := False;
      Alignment := taCenter;
      Font.Size := 20;
      Font.Style := [fsBold];
      Caption := '';
      Visible := False;
    end;
    BundeTiderForm.InsertControl(BundePlaceringLabels[i]);
  end;
end;

procedure NewGame;
{ Kaldes ved start af nyt spil;
  skriv evt. initialiseringer ved start af nyt spil;
  HUSK frst at kalde free for alle skabte objekter fra
  evt. tidligere spil  }
begin
  Selection:=TSelection.create;
  CTable.clear;
  a := TPile.Create(8, 24, 0, 0);
  b := TPile.Create(88, 24, 0, 0);
  c := TPile.Create(168, 24, 0, 0);
  d := TPile.Create(248, 24, 0, 0);
  bunke := TPile.Create(100, 100, 0, 0);
  bunke.make52(False);
  a.insertAtTop(bunke.Find(Club,2));
  b.insertAtTop(bunke.Find(Club,3));
  c.insertAtTop(bunke.Find(Club,4));
  d.insertAtTop(bunke.Find(Club,5));
  CTable.addPile(a);
  CTable.addPile(b);
  CTable.addPile(c);
  CTable.addPile(d);
end;

procedure ValgtKortNil;
begin
  ValgtKort := nil;
end;

procedure MouseDown(Pile: TPile; Card: TCard);
{ kaldes ved MouseDown i bunken Pile p kortet Card;
  skriv kode der skal udfres ved MouseDown }
begin
// MouseDown procedure
end;

procedure MouseUp(Pile: TPile; Card: TCard);
{ kaldes ved MouseUp i bunken Pile p kortet Card;
  skriv kode der skal udfres ved MouseUp }
begin
// MouseUp procedure
end;

procedure FlytEs(S: Char; V: Integer);
var
  IndsaetHvor : TPile;
begin
  IndsaetHvor := a;
  case S of
  's' :
      ValgtEs := bunke.Find(SPADE, V);
  'k' :
      ValgtEs := bunke.Find(CLUB, V);
  'r' :
      ValgtEs := bunke.Find(DIAMOND, V);
  'h' :
      ValgtEs := bunke.Find(HEART, V);
  end;
  case NaesteEs of
    1 : Indsaethvor := a;
    2 : Indsaethvor := b;
    3 : Indsaethvor := c;
    4 : Indsaethvor := d;
  end;
  IndsaetHvor.insertAtTop(ValgtEs);
  IndsaetHvor.flipTop;
  inc(NaesteEs);
end;

procedure FortrydEs(S: Char; V: Integer);
var
  FjernHvor : TPile;
begin
  FjernHvor := a;
  case NaesteEs - 1 of
    1 : FjernHvor := a;
    2 : FjernHvor := b;
    3 : FjernHvor := c;
    4 : FjernHvor := d;
  end;
  FjernHvor.flipTop;
  dec(NaesteEs);
end;

end.
