unit Bundegui;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ComCtrls, Gauges;

   procedure IndsaetBundning(Fortrudt: Boolean);

type
  TBundeTiderForm = class(TForm)
    procedure FormPaint(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
     procedure EraseRect(HFillrect,VFillRect: TRect);
     procedure DrawEmptyPile(aType: integer;x1,y1: integer);
     procedure CardDrawInverted(x,y,CardNr: integer);
     procedure CardDraw(x,y,CardNr: integer);
     procedure BackDraw(x,y,BackNr: integer);
  end;

var
  BundeTiderForm: TBundeTiderForm;
  BunderNavnEdits, TidEdits : array [1..4] of TEdit;
  EsLabels, NavnLabels, TidLabels, BundePlaceringLabels : array [1..4] of TLabel;

implementation

{$R *.DFM}

uses Bundecardclasses, cardFkt, BundeEventu, MainUnit;

procedure TBundeTiderForm.EraseRect(HFillrect,VFillRect: TRect);
begin
  Canvas.brush.Color:=Color;
  Canvas.FillRect(HFillRect);
  Canvas.FillRect(VFillRect);
end;

procedure TBundeTiderForm.DrawEmptyPile(aType: integer;x1,y1: integer);
const d=5;
var i: integer;
begin
  case aType of
    1: _BackDraw(Canvas,x1,y1,14);
    2: _BackDraw(Canvas,x1,y1,13);
    else
      Canvas.Pen.Color:=clLime;
      for i:=0 to 1 do
        Canvas.RoundRect(x1+i,y1+i,x1+CardWidth-i,y1+CardHeight-i,d,d);
  end
end;

procedure TBundeTiderForm.CardDrawInverted(x,y,CardNr: integer);
begin
  _CardDrawInverted(BundeTiderForm.Canvas,x,y,CardNr);
end;

procedure TBundeTiderForm.CardDraw(x,y,CardNr: integer);
begin
  _CardDraw(BundeTiderForm.Canvas,x,y,CardNr);
end;

procedure TBundeTiderForm.BackDraw(x,y,BackNr: integer);
begin
  _BackDraw(BundeTiderForm.Canvas,x,y,BackNr);
end;

procedure TBundeTiderForm.FormPaint(Sender: TObject);
begin
  CTable.Refresh;
end;

procedure TBundeTiderForm.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var p: TPile; c: TCard;
begin
  if Button <> mbLeft then Exit;
  CTable.GetPileCardAt(x,y,p,c);
  if p<>nil then Bundeeventu.MouseDown(p,c);
end;

procedure TBundeTiderForm.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var p: TPile; c: TCard;
begin
  if Button <> mbLeft then Exit;
  CTable.GetPileCardAt(x,y,p,c);
  if p<>nil then Bundeeventu.MouseUp(p,c);
end;

procedure TBundeTiderForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//  CTable.Clear;
end;

procedure TBundeTiderForm.FormCreate(Sender: TObject);
begin
  ProgInit;
end;

procedure TBundeTiderForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := False;
end;

procedure IndsaetBundning(Fortrudt: Boolean);
var
  i, x, placering : Integer;
begin
  for i := 1 to 4 do
  begin
    EsLabels[i].Enabled := False;
    NavnLabels[i].Enabled := False;
    TidLabels[i].Enabled := False;
    BundePlaceringLabels[i].Visible := False;
    BunderNavnEdits[i].Text := SpillerBundeTid[i, 1];
    TidEdits[i].Text :=  SpillerBundeTid[i, 2];
  end;
  if not Fortrudt then x := NaesteEs else x := NaesteEs - 1;
  for i := 1 to x do
  begin
    EsLabels[i].Enabled := True;
    NavnLabels[i].Enabled := True;
    TidLabels[i].Enabled := True;
    BundePlaceringLabels[i].Caption := IntToStr(BundePlacering[i]);
    if BundePlacering[i] > 0 then BundePlaceringLabels[i].Visible := True;
  end;
end;

end.
