unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Menus, StdCtrls, Buttons, ImgList;

  procedure SpilSlut();
  procedure IndsaetBundeTider();
  procedure IndsaetVaerdi(Vaerdi: Integer);

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    Filer1: TMenuItem;
    NytSpil1: TMenuItem;
    Afslut1: TMenuItem;
    Hjlp1: TMenuItem;
    Vejledning1: TMenuItem;
    N1: TMenuItem;
    ImageList1: TImageList;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Gem1: TMenuItem;
    bn1: TMenuItem;
    Om1: TMenuItem;
    N2: TMenuItem;
    Label1: TLabel;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure NytSpil1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Afslut1Click(Sender: TObject);
    procedure Gem1Click(Sender: TObject);
    procedure bn1Click(Sender: TObject);
    procedure Vejledning1Click(Sender: TObject);
    procedure Om1Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;
  SlurkeImages: array [1..6] of TImage;
  Kulor: String;
  Vaerdi, AntalSpillere, Spiller, Runde, KortBrugt, SumIAlt,
  SlurkePrOel, NaesteEs: Integer;
  BundePlacering: array [1..4] of Integer;
  BundeTid: TDateTime;
  SpillerNavn: array [1..6] of String;
  KortFraBunke, KortValgt, SpilIGang, KortFortrudt : Boolean;
  SpillerSum, StartSlurke, SpillerSlurke: array [1..6] of Integer;
  RundeSum : array [1..52] of Integer;
  RundePoint : array [1..52, 1..6] of Integer;
  SpillerFarve: array [1..6] of TColor;
  SpillerBundeTid: array [1..4, 1..2] of String; // 1. kolonne: spiller, 2.: tid

const
  MinSpillere : Integer = 1;
  MaxSpillere : Integer = 6;

implementation

uses HistorikUnit, StatistikUnit, OverblikUnit, SlurkeUnit,
       eventu, eventu2, Bundeeventu, NytSpilUnit, gui2, gui, Bundegui,
       SlutStatistikUnit, VejledningUnit, OmUnit, BundeUnit;

{$R *.dfm}

procedure NyStatistik();
var
  i : Integer;
begin
  for i := MinSpillere to MaxSpillere do
  begin
    StatistikForm.Chart1.Series[i - 1].Clear;
    StatistikForm.Chart1.Series[i - 1].ShowInLegend := False;
  end;
  for i := 1 to AntalSpillere do
  begin
    StatistikForm.Chart1.Series[i - 1].AddXY(0, 0);
    StatistikForm.Chart1.Series[i - 1].ShowInLegend := True;
    StatistikForm.Chart1.Series[i - 1].Title := SpillerNavn[i];
  end;
  Statistikform.Chart1.Series[6].Clear;
  Statistikform.Chart1.Series[6].AddXY(0, 0);
  Statistikform.Chart1.Series[7].Clear;
  Statistikform.Chart1.Series[7].AddXY(0, 0);
end;

procedure SkrivBundePlacering();
var
  i, j, x : Integer;
begin
  for i := 1 to 4 do
  begin
    x := 0;
    if SpillerBundeTid[i, 2] <> '' then x := 1;
    for j := 1 to 4 do
    if i <> j then
    begin
      if (SpillerBundeTid[i, 2] > SpillerBundeTid[j, 2]) and (SpillerBundeTid[j, 2] <> '') then inc(x);
    end;
    BundePlacering[i] := x
  end;
end;

procedure NytSpil();
var
  i, j : Integer;
begin
  Vaerdi := 0;
  Spiller := 1;
  Runde := 1;
  KortBrugt := 0;
  NaesteEs := 1;
  for i := 1 to 52 do
    RundeSum[i] := 0;
  for i := 1 to 6 do
    for j := 1 to 52 do
      RundePoint[i,j] := 0;
  for i := MinSpillere to MaxSpillere do
    SpillerSum[i] := 0;
  for i := 1 to 4 do
    for j := 1 to 2 do
    begin
      SpillerBundeTid[i,j] := '';
      BundePlacering[i] := 0;
    end;
  SpilIGang := True;
  KortFraBunke := False;
  KortFortrudt := False;
  TegnGrid1;
  TegnForm1;
  TegnGrid3;
  TegnOverblikForm;
  TegnGrid4;
  TegnSlurkeForm;
  NyStatistik;
  SlurkeForm.Edit1.Text := IntToStr(SlurkePrOel);
  for i := 1 to AntalSpillere do
    StatistikForm.Chart1.Series[i - 1].SeriesColor := SpillerFarve[i];
  FrmBord.Left := 10; FrmBord.Top := MainForm.Height + 10;
  SlurkeForm.Left := FrmBord.Left; SlurkeForm.Top := FrmBord.Height + FrmBord.Top + 5;
  FrmBord2.Left := FrmBord.Left + FrmBord.Width - FrmBord2.Width; FrmBord2.Top := FrmBord.Height + FrmBord.Top + 5;
  if FrmBord2.Left < SlurkeForm.Left + SlurkeForm.Width then FrmBord2.Left := SlurkeForm.Left + SlurkeForm.Width + 5;
  StatistikForm.Left := FrmBord.Left + FrmBord.Width + 5; StatistikForm.Top := FrmBord.Top;
  HistorikForm.Left := FrmBord2.Left + FrmBord2.Width + 5; HistorikForm.Top := StatistikForm.Top + StatistikForm.Height + 5;
  OverblikForm.Left := FrmBord.Left; OverblikForm.Top := SlurkeForm.Top + SlurkeForm.Height + 5;
  BundeTiderForm.Left := HistorikForm.Left + HistorikForm.Width + 5; BundeTiderForm.Top := HistorikForm.Top;
  HistorikForm.Show;
  StatistikForm.Show;
  SlurkeForm.Show;
  OverblikForm.Show;
  BundeTiderForm.Show;
  FrmBord.Show;
  FrmBord2.Show;
  eventu.NewGame;
  eventu2.NewGame;
  Bundeeventu.NewGame;
  SkrivBundePlacering;
  IndsaetBundning(True);
  TegnImages4;
  OpdaterImages4;
end;

procedure OpdaterStatistik();
var
  i, s : Integer;
begin
  s := 0;
  if KortFortrudt then
  begin
    StatistikForm.Chart1.Series[Spiller - 1].Delete(Runde)
  end
  else
  begin
    Statistikform.Chart1.Series[Spiller - 1].AddXY(Runde, SpillerSum[Spiller]);
  end;
  // Opdater Gennemsnit
  if KortFortrudt then
  begin
    StatistikForm.Chart1.Series[6].Delete(Runde);
    if Spiller > 1 then
    begin
      for i := 1 to Spiller - 1 do
        s := s + RundePoint[Runde, i];
      StatistikForm.Chart1.Series[6].AddXY(Runde, s / (Spiller - 1) + Statistikform.Chart1.Series[6].YValue[Runde - 1]);
    end;
    if Spiller = 1 then
      Statistikform.Chart1.Series[7].Delete(Runde);   //Normal-kurve
  end
  else
  begin
    if Spiller > 1 then
      StatistikForm.Chart1.Series[6].Delete(Runde);
    for i := 1 to Spiller do
      s := s + RundePoint[Runde, i];
    StatistikForm.Chart1.Series[6].AddXY(Runde, s / (Spiller) + Statistikform.Chart1.Series[6].YValue[Runde - 1]);
    if Spiller = 1 then
      Statistikform.Chart1.Series[7].AddXY(Runde, Runde * 8);   //Normal-kurve
  end;
end;

procedure IndsaetBundeTider();
var
  i : Integer;
begin
  if not KortFortrudt then
  begin
    SpillerBundeTid[NaesteEs, 1] := SpillerNavn[Spiller];
    SpillerBundeTid[NaesteEs, 2] := FormatDateTime('nn:ss.zzz', BundeTid);
  end else
  begin
    SpillerBundeTid[NaesteEs, 1] := '';
    SpillerBundeTid[NaesteEs, 2] := '';
  end;
  SkrivBundePlacering;
  IndsaetBundning(KortFortrudt);
end;

procedure IndsaetVaerdi(Vaerdi: Integer);
var
  i, j, x : Integer;
begin
  if Vaerdi < 0 then
  begin
    HistorikForm.StringGrid1.Cells[Spiller,Runde] := '';
    RundePoint[Runde, Spiller] := 0;
  end
  else
  begin
    HistorikForm.StringGrid1.Cells[Spiller,Runde] := IntToStr(Vaerdi);
    RundePoint[Runde, Spiller] := Vaerdi;
  end;
  if Vaerdi = 14 then BundeForm.ShowModal;
  if (Vaerdi = 14) or (Vaerdi = -14) then IndsaetBundeTider;
  SpillerSum[Spiller] := SpillerSum[Spiller] + Vaerdi;
  SumIalt := 0;
  for i := 1 to AntalSpillere do
    SumIalt := SumIalt + SpillerSum[i];
  if KortFortrudt then
  begin
    if Spiller = 1 then RundeSum[Runde] := RundeSum[Runde] + Vaerdi
    else RundeSum[Runde] := RundeSum[Runde] + Vaerdi;
  end
  else
  begin
    if Spiller = 1 then RundeSum[Runde] := Vaerdi
    else RundeSum[Runde] := RundeSum[Runde] + Vaerdi
  end;
  OverblikForm.StringGrid1.Cells[Spiller, 1] := IntToStr(SpillerSum[Spiller]);
  OverblikForm.StringGrid1.Cells[Spiller, 2] := FloatToStr(SpillerSum[Spiller] / SlurkePrOel);
  OverblikForm.StringGrid1.Cells[Spiller, 3] := FloatToStr(SpillerSum[Spiller] / Runde);
  OverblikForm.StringGrid1.Cells[AntalSpillere + 1, 1] := IntToStr(SumIAlt);
  OverblikForm.StringGrid1.Cells[AntalSpillere + 1, 2] := FloatToStr(SumIAlt / SlurkePrOel);
  if KortBrugt < 1 then OverblikForm.StringGrid1.Cells[AntalSpillere + 1, 3] := '0'
  else OverblikForm.StringGrid1.Cells[AntalSpillere + 1, 3] := FloatToStr(SumIalt / KortBrugt);
  SpillerSlurke[Spiller] := SlurkePrOel - (SpillerSum[Spiller] + SlurkePrOel - StartSlurke[Spiller]) mod SlurkePrOel;
  if SpillerSlurke[Spiller] = 0 then SpillerSlurke[Spiller] := SlurkePrOel;
  SlurkeForm.StringGrid1.Cells[Spiller - 1, 1] := IntToStr(SpillerSlurke[Spiller]);
  OpdaterStatistik;
  OpdaterImages4;
end;

procedure SpilSlut();
var
  i : Integer;
begin
  if Spiller <> 1 then
    for i := 1 to AntalSpillere - Spiller + 1 do
    begin
      Indsaetvaerdi(0);
      inc(Spiller);
    end;
  SpilIgang := False;
  SlutStatistikForm.ShowModal;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  i : Integer;
begin
  Width := Screen.Width;
  Height := 51;
  Top := 0; Left := 0;
  for i := 1 to 6 do
    SpillerNavn[i] := 'Spiller ' + IntToStr(i);
  for i := 1 to MaxSpillere do
    StartSlurke[i] := SlurkePrOel;
end;

procedure TMainForm.Afslut1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.NytSpil1Click(Sender: TObject);
begin
  if NytSpilForm.ShowModal <> mrOk then Exit;
  NytSpil;
end;

procedure TMainForm.Gem1Click(Sender: TObject);
var
  i : Integer;
  F : TextFile;
begin
  if SaveDialog1.Execute then
  begin
    AssignFile(F, SaveDialog1.FileName);
    ReWrite(F);
    WriteLn(F, AntalSpillere);
    WriteLn(F, SlurkePrOel);
    for i := 1 to MaxSpillere do
    begin
      WriteLn(F, SpillerNavn[i]);
      WriteLn(F, StartSlurke[i]);
      WriteLn(F, SpillerFarve[i]);
    end;
    for i := 1 to KortBrugt do
      WriteLn(F,(HentFarve(i) + HentNr(i)));
    CloseFile(F);
  end;
end;

procedure TMainForm.bn1Click(Sender: TObject);
var
  i, Nr : Integer;
  Ch : Char;
  F : TextFile;
begin
  if OpenDialog1.Execute then
  begin
    AssignFile(F, OpenDialog1.FileName);
    Reset(F);
    ReadLn(F, AntalSpillere);
    ReadLn(F, SlurkePrOel);
    for i := 1 to MaxSpillere do
    begin
      ReadLn(F, SpillerNavn[i]);
      ReadLn(F, StartSlurke[i]);
      ReadLn(F, SpillerFarve[i]);
    end;
    NytSpil;
    HistorikForm.Visible := False;
    OverblikForm.Visible := False;
    SlurkeForm.Visible := False;
    FrmBord.Visible := False;
    FrmBord2.Visible := False;
    while not Eof(F) do
    begin
      Read(F, Ch);
      Read(F, Nr);
      ReadLn(F);
      BrugKort(Ch, Nr);
    end;
    CloseFile(F);
    KortFraBunke := True;
    ValgtKortNil;
    HistorikForm.Visible := True;
    OverblikForm.Visible := True;
    SlurkeForm.Visible := True;
    FrmBord.Visible := True;
    FrmBord2.Visible := True;
  end;
end;

procedure TMainForm.Vejledning1Click(Sender: TObject);
begin
  VejledningForm.ShowModal;
end;

procedure TMainForm.Om1Click(Sender: TObject);
begin
  OmForm.ShowModal;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if SpilIGang then if Application.MessageBox('Vil du virkelig lukke?','Spillet er i gang',mb_YesNo) = 7 then CanClose := False;
end;

initialization
  SpilIGang := False;
  AntalSpillere := 3;
  SlurkePrOel := 14;
  SpillerFarve[1] := clRed;
  SpillerFarve[2] := clBlue;
  SpillerFarve[3] := clYellow;
  SpillerFarve[4] := clGreen;
  SpillerFarve[5] := clTeal;
  SpillerFarve[6] := clPurple;
  Randomize;
end.
