unit NytSpilUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, ImgList, Mask, AppEvnts, ToolWin,
  ActnMan, ActnCtrls, ActnList, Buttons, Math;

type
  TNytSpilForm = class(TForm)
    Label1: TLabel;
    ColorDialog1: TColorDialog;
    Label2: TLabel;
    NavnLabel: TLabel;
    FarveLabel: TLabel;
    StartSlurkeLabel: TLabel;
    Panel0: TPanel;
    TrackBar1: TTrackBar;
    Label01: TLabel;
    Label03: TLabel;
    Label04: TLabel;
    Label05: TLabel;
    Label06: TLabel;
    Label02: TLabel;
    UpDown1: TUpDown;
    SlurkeEdit: TEdit;
    Label6: TLabel;
    OKBitBtn: TBitBtn;
    AnnullerBitBtn: TBitBtn;
    procedure TrackBar1Change(Sender: TObject);
    procedure SlurkeEditChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure OKBitBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    procedure FarvePanelClick(Sender: TObject);
    procedure FarvePanelMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FarvePanelMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure StartSlurkeTrackBarChange(Sender: TObject);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  NytSpilForm: TNytSpilForm;
  NavnEdits, StartSlurkeEdits: array [1..6] of TEdit;
  FarvePanels: array [1..6] of TPanel;
  StartSlurkeTrackBars: array [1..6] of TTrackBar;
  StartSlurkeImages: array [1..6] of TImage;
  StartSlurkeTrackBarLabels1, StartSlurkeTrackBarLabelsEnd: array [1..6] of TLabel;
  NyAntalSpillere, NySlurkePrOel : Integer;
  NySpillerFarve : array [1..6] of TColor;

const
  MinSlurke : Integer = 1;
  MaxSlurke : Integer = 20;

implementation

uses MainUnit;

{$R *.dfm}

function VaelgFarve(Spillernr : Integer): TColor;
begin
  with NytSpilForm.ColorDialog1 do
  begin
    Color := NySpillerFarve[Spillernr];
    Execute;
    Result := Color;
  end;
end;

procedure TNytSpilForm.FarvePanelClick(Sender: TObject);
var
  i, Nr : Integer;
begin
  Nr := 0;
  for i := 1 to NyAntalSpillere do
    if Sender = FarvePanels[i] then Nr := i;
  NySpillerFarve[Nr] := VaelgFarve(Nr);
  try
    FarvePanels[Nr].Color := NySpillerFarve[Nr]
  except
    on EAccessViolation do ShowMessage('Fejl!')
  end;
end;

procedure TNytSpilForm.FarvePanelMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  i, Nr : Integer;
begin
  if Button <> mbLeft then Exit;
  Nr := 0;
  for i := 1 to NyAntalSpillere do
    if Sender = FarvePanels[i] then Nr := i;
  try
    FarvePanels[Nr].BevelInner := bvLowered;
    FarvePanels[Nr].BevelOuter := bvLowered;
  except
    on EAccessViolation do ShowMessage('Fejl!')
  end;
end;

procedure OpdaterStartSlurke();
var
  i : Integer;
begin
  for i := 1 to MaxSpillere do
  begin
    StartSlurkeTrackBars[i].Max := NySlurkePrOel;
    StartSlurkeTrackBars[i].Position := StartSlurke[i];
    StartSlurkeEdits[i].Text := IntToStr(StartSlurke[i]);
    if i <= NyAntalSpillere then
      MainForm.ImageList1.Draw(StartSlurkeImages[i].Canvas, 0, 0,
      StrToInt(FloatToStr(SimpleRoundTo(StartSlurke[i] / NySlurkePrOel * 20, 0))))
    else
      MainForm.ImageList1.Draw(StartSlurkeImages[i].Canvas,0,0,21);
    StartSlurkeImages[i].Repaint;
  end;
end;

procedure TNytSpilForm.StartSlurkeTrackBarChange(Sender: TObject);
var
  i, Nr : Integer;
begin
  Nr := 0;
  for i := 1 to MaxSpillere do
    if Sender = StartSlurkeTrackBars[i] then Nr := i;
  try
    StartSlurke[Nr] := StartSlurkeTrackBars[Nr].Position;
  except
    on EAccessViolation do ShowMessage('Fejl!')
  end;
  OpdaterStartSlurke;
end;

procedure TNytSpilForm.FarvePanelMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  i, Nr : Integer;
begin
  if Button <> mbLeft then Exit;
  Nr := 0;
  for i := 1 to NyAntalSpillere do
    if Sender = FarvePanels[i] then Nr := i;
  try
    FarvePanels[Nr].BevelInner := bvRaised;
    FarvePanels[Nr].BevelOuter := bvRaised;
  except
    on EAccessViolation do ShowMessage('Fejl!')
  end;
end;

procedure EnableSpillere();
var
  i : Integer;
begin
  for i := NyAntalSpillere + 1 to MaxSpillere do
    with NytSpilForm do
    begin
      NavnEdits[i].Enabled := False;
      FarvePanels[i].Enabled := False;
      FarvePanels[i].Color := clGray;
      StartSlurkeTrackBars[i].Enabled := False;
      StartSlurkeTrackBarLabels1[i].Font.Color := clGrayText;
      StartSlurkeTrackBarLabelsEnd[i].Font.Color := clGrayText;
      StartSlurkeEdits[i].Font.Color := clGrayText;
    end;
  for i := 1 to NyAntalSpillere do
    with NytSpilForm do
    begin
      NavnEdits[i].Enabled := True;
      FarvePanels[i].Enabled := True;
      FarvePanels[i].Color := NySpillerFarve[i];
      StartSlurkeTrackBars[i].Enabled := True;
      StartSlurkeTrackBarLabels1[i].Font.Color := clWindowText;
      StartSlurkeTrackBarLabelsEnd[i].Font.Color := clWindowText;
      StartSlurkeEdits[i].Font.Color := clWindowText;
    end;
end;

procedure TNytSpilForm.TrackBar1Change(Sender: TObject);
begin
  NyAntalSpillere := TrackBar1.Position;
  EnableSpillere;
  OpdaterStartSlurke;
end;

procedure TNytSpilForm.SlurkeEditChange(Sender: TObject);
var
  i : Integer;
begin
  if not NytSpilForm.Active then Exit;
  NySlurkePrOel := UpDown1.Position;
  for i := 1 to MaxSpillere do
    StartSlurkeTrackBarLabelsEnd[i].Caption := IntToStr(NySlurkePrOel);
  OpdaterStartSlurke;
end;

procedure TNytSpilForm.FormCreate(Sender: TObject);
var
  i : Integer;
begin
  Left := Screen.Width div 2 - Width div 2;
  Top := Screen.Height div 2 - Height div 2;
  for i := 1 to MaxSpillere do
  begin
    NavnEdits[i] := TEdit.Create(NytSpilForm);
    with NavnEdits[i] do
    begin
      Name := 'NavnEdit' + IntToStr(i);
      Left := NavnLabel.Left;  Top := (i-1) * 32 + 37;
      Width := 120;  Height := 21;
    end;
    InsertControl(NavnEdits[i]);
    FarvePanels[i] := TPanel.Create(NytSpilForm);
    with FarvePanels[i] do
    begin
      Name := 'FarvePanel' + IntToStr(i);
      Caption := '';
      BevelInner := bvRaised;  BevelOuter := bvRaised;
      Cursor := crHandPoint;
      Left := FarveLabel.Left;  Top := (i-1) * 32 + 37;
      Width := 25;  Height := 25;
      OnClick := FarvePanelClick;
      OnMouseDown := FarvePanelMouseDown;
      OnMouseUp := FarvePanelMouseUp;
    end;
    InsertControl(FarvePanels[i]);
    StartSlurkeTrackBars[i] := TTrackBar.Create(NytSpilForm);
    with StartSlurkeTrackBars[i] do
    begin
      Name := 'StartSlurkeTrackBar' + IntToStr(i);
      Frequency := 1;  LineSize := 1;
      ThumbLength := 10;
      Left := StartSlurkeLabel.Left;  Top := (i-1) * 32 + 40;
      Width := 65;  Height := 17;
      OnChange := StartSlurkeTrackBarChange;
    end;
    InsertControl(StartSlurkeTrackBars[i]);
    StartSlurkeTrackBarLabels1[i] := TLabel.Create(NytSpilForm);
    with StartSlurkeTrackBarLabels1[i] do
    begin
      Name := 'StartSlurkeTrackBarLabel1' + IntToStr(i);
      Left := StartSlurkeLabel.Left + 2;  Top := StartSlurkeTrackBars[i].Top + 16;
      Width := 5;  Height := 5;
      Font.Size := 1;
      Caption := '1';
    end;
    InsertControl(StartSlurkeTrackBarLabels1[i]);
    StartSlurkeTrackBarLabelsEnd[i] := TLabel.Create(NytSpilForm);
    with StartSlurkeTrackBarLabelsEnd[i] do
    begin
      Name := 'StartSlurkeTrackBarLabelEnd' + IntToStr(i);
      Left := StartSlurkeLabel.Left + StartSlurkeLabel.Width;  Top := StartSlurkeTrackBars[i].Top + 16;
      Width := 5;  Height := 5;
      Font.Size := 1;
    end;
    InsertControl(StartSlurkeTrackBarLabelsEnd[i]);
    StartSlurkeEdits[i] := TEdit.Create(NytSpilForm);
    with StartSlurkeEdits[i] do
    begin
      Name := 'StartSlurkeEdit' + IntToStr(i);
      Left := StartSlurkeTrackBars[i].Left + StartSlurkeTrackBars[i].Width + 6;  Top := StartSlurkeTrackBars[i].Top;
      Width := 20;  Height := 20;
      Color := clMenu;
      ReadOnly := True;
    end;
    InsertControl(StartSlurkeEdits[i]);
    StartSlurkeImages[i] := TImage.Create(NytSpilForm);
    with StartSlurkeImages[i] do
    begin
      case i of
      1,3,5 : begin
                Left := StartSlurkeEdits[i].Left + StartSlurkeEdits[i].Width + 5;
                Top := (i div 2) * 67 + 17;
              end;
      2,4,6 : begin
                Left := StartSlurkeEdits[i].Left + StartSlurkeEdits[i].Width + 28;
                Top := (i div 2 - 1) * 67 + 50;
              end;
      end;
      Name := 'StartSlurkeImage' + IntToStr(i);
      Width := 19;  Height := 54;
    end;
    InsertControl(StartSlurkeImages[i]);
   end;
  UpDown1.Min := MinSlurke;
  UpDown1.Max := MaxSlurke;
end;

procedure TNytSpilForm.OKBitBtnClick(Sender: TObject);
var
  i : Integer;
begin
  SlurkePrOel := StrToInt(SlurkeEdit.Text);
  AntalSpillere := NyAntalSpillere;
  for i := 1 to MaxSpillere do
  begin
    SpillerFarve[i] := NySpillerFarve[i];
    SpillerNavn[i] := NavnEdits[i].Text;
    SpillerSlurke[i] := StartSlurke[i];
  end;
end;

procedure TNytSpilForm.FormShow(Sender: TObject);
var
  i : Integer;
begin
  NySlurkePrOel := SlurkePrOel;
  for i := 1 to MaxSpillere do
  begin
    NavnEdits[i].Text := SpillerNavn[i];
    FarvePanels[i].Color := SpillerFarve[i];
    StartSlurkeTrackBars[i].Min := MinSlurke;
    StartSlurkeTrackBars[i].Max := NySlurkePrOel;
    StartSlurkeTrackBarLabelsEnd[i].Caption := IntToStr(NySlurkePrOel);
    StartSlurkeEdits[i].Text := IntToStr(StartSlurke[i]);
    NySpillerFarve[i] := SpillerFarve[i];
    StartSlurke[i] := NySlurkePrOel;
  end;
  TrackBar1.Position := AntalSpillere;
  UpDown1.Position := NySlurkePrOel;
  NyAntalSpillere := AntalSpillere;
  OpdaterStartSlurke;
  EnableSpillere;
end;

end.
