unit SlutStatistikUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Grids, ValEdit, Math, Buttons;

  procedure TegnSlutStatistikForm();

type
  TSlutStatistikForm = class(TForm)
    BitBtn1: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SlutStatistikForm: TSlutStatistikForm;
  NavnLabels: array [1..6] of TLabel;
  StatistikValueListEditors: array [1..6] of TValueListEditor;
  OelImages: array [1..6, 1..31] of TImage;

implementation

uses MainUnit;

{$R *.dfm}

procedure TegnSlutStatistikForm();
var
  i, j, FlestFlasker : Integer;
  RundAf : TFPURoundingMode;
  SpillerFlasker, SlutSlurke : array [1..6] of Integer;
begin
  FlestFlasker := 0;
  for i := 1 to MaxSpillere do
  begin
    NavnLabels[i].Hide;
    StatistikValueListEditors[i].Hide;
  end;
  for i := 1 to AntalSpillere do
  begin
    SlutSlurke[i] := SlurkePrOel - SpillerSlurke[i];
    if SlutSlurke[i] = 0 then SlutSlurke[i] := SlurkePrOel;
    RundAf := GetRoundMode;
    SetRoundMode(rmUp);
    SpillerFlasker[i] := Round((SpillerSum[i] - StartSlurke[i]) / SlurkePrOel + 1);
    SetRoundMode(RundAf);
    if SpillerFlasker[i] > FlestFlasker then
      FlestFlasker := SpillerFlasker[i];
    NavnLabels[i].Caption := SpillerNavn[i];
    NavnLabels[i].Show;
    with StatistikValueListEditors[i] do
    begin
        InsertRow('Slurke', IntToStr(SpillerSum[i]), True);
      InsertRow('l', FloatToStr(Round(100 * SpillerSum[i] / SlurkePrOel) / 100), True);
      InsertRow('Gns. sl./omg.', FloatToStr(Round(100 * SpillerSum[i] / Runde) / 100), True);
    end;
    StatistikValueListEditors[i].Show;
    for j := 1 to 31 do
    begin
      with OelImages[i, j] do
      begin
        Left := StatistikValueListEditors[i].Left + 2;
        case j of
        2, 7, 12, 17, 22, 27 :
          begin
            Left := Left + 21;
          end;
        3, 8, 13, 18, 23, 28 :
          begin
            Left := Left + 21 + 21;
          end;
        4, 9, 14, 19, 24, 29 :
          begin
            Left := Left + 21 + 21 + 21;
          end;
        5, 10, 15, 20, 25, 30 :
          begin
            Left := Left + 21 + 21 + 21 + 21;
          end;
        end;
        Top := StatistikValueListEditors[i].Top +
                 StatistikValueListEditors[i].Height +
                 ((j + 4) div 5 - 1) * 58 + 3;
      end;
      if j = 1 then
        MainForm.ImageList1.Draw(OelImages[i, j].Canvas, 0, 0,
          StrToInt(FloatToStr(SimpleRoundTo(StartSlurke[i] / SlurkePrOel * 20, 0))));
      if (j > 1) and (j < SpillerFlasker[i]) then
        MainForm.ImageList1.Draw(OelImages[i, j].Canvas, 0, 0, 20);
      if j = SpillerFlasker[i] then
        MainForm.ImageList1.Draw(OelImages[i, j].Canvas, 0, 0,
          StrToInt(FloatToStr(SimpleRoundTo(SlutSlurke[i] / SlurkePrOel * 20, 0))));
    end;
    for j := 1 to SpillerFlasker[i] do
    begin
      OelImages[i, j].Repaint;
      OelImages[i, j].Show;
    end;
  end;
  with SlutStatistikForm do
  begin
    RundAf := GetRoundMode;
    SetRoundMode(rmUp);
    Width := (StatistikValueListEditors[1].Width + 5) * AntalSpillere + 10;
    Height := Round(FlestFlasker / 5) * (OelImages[1, 1].Height + 4) + OelImages[1, 1].Top + 60;
    SetRoundMode(RundAf);
    with BitBtn1 do
    begin
      Top := SlutStatistikForm.Height - Height - 36;
      Left := SlutStatistikForm.Width div 2 - Width div 2;
    end;
  end;
end;

procedure TSlutStatistikForm.FormCreate(Sender: TObject);
var
  i, j : Integer;
begin
  for i := 1 to MaxSpillere do
  begin
    NavnLabels[i] := TLabel.Create(SlutStatistikForm);
    with NavnLabels[i] do
    begin
      Name := 'NavnLabel' + IntToStr(i);
      Left := (i-1) * 120 + 10; Top := 5;
      Width := 107;  Height := 21;
    end;
    InsertControl(NavnLabels[i]);
    StatistikValueListEditors[i] := TValueListEditor.Create(SlutStatistikForm);
    with StatistikValueListEditors[i] do
    begin
      Name := 'StatistikValueListEditors' + IntToStr(i);
      Left := NavnLabels[i].Left; Top := 30;
      Width := 118;  Height := 60;
      Color := clBtnFace;
      DefaultColWidth := 50;
      DisplayOptions := [doAutoColResize, doKeyColFixed];
      Options := [goFixedVertLine,goFixedHorzLine,goVertLine,
                   goHorzLine,goRangeSelect];
      ScrollBars := ssNone;
      DefaultColWidth := 68;
    end;
    InsertControl(StatistikValueListEditors[i]);
    for j := 1 to 31 do
    begin
      OelImages[i, j] := TImage.Create(SlutStatistikForm);
      with OelImages[i, j] do
      begin
        Name := 'OelImage' + IntToStr(i) + IntToStr(j);
        Width := 19;  Height := 54;
        Visible := False;
      end;
      InsertControl(OelImages[i, j]);
      OelImages[i, j].Hide;
    end;
  end;
end;

procedure TSlutStatistikForm.Button1Click(Sender: TObject);
begin
  TegnSlutStatistikForm;
end;

procedure TSlutStatistikForm.FormShow(Sender: TObject);
begin
  TegnSlutStatistikForm;
end;

end.


