unit StatistikUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, Series, ExtCtrls, TeeProcs, Chart, TeeFunci;

type
  TStatistikForm = class(TForm)
    Chart1: TChart;
    Series1: TFastLineSeries;
    Series2: TFastLineSeries;
    Series3: TFastLineSeries;
    Series4: TFastLineSeries;
    Series5: TFastLineSeries;
    Series6: TFastLineSeries;
    Series7: TFastLineSeries;
    TeeFunction1: TAverageTeeFunction;
    Series8: TFastLineSeries;
    procedure Chart1UndoZoom(Sender: TObject);
    procedure Chart1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Chart1Scroll(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Chart1Zoom(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  StatistikForm: TStatistikForm;
  Scrolled, Zoomed : Boolean;

implementation

uses MainUnit;

{$R *.dfm}

procedure TStatistikForm.Chart1UndoZoom(Sender: TObject);
begin
  Chart1.BottomAxis.AutomaticMaximum := True;
  Chart1.LeftAxis.AutomaticMaximum := True;
  Zoomed := False;
end;

procedure TStatistikForm.Chart1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button <> mbRight then Exit;
  if (not Scrolled) and (not Zoomed) then
  begin
    Chart1.BottomAxis.Minimum := 0;
    Chart1.LeftAxis.Minimum := 0;
    Chart1.BottomAxis.AutomaticMaximum := True;
    Chart1.LeftAxis.AutomaticMaximum := True;
  end
  else Scrolled := False;
end;

procedure TStatistikForm.Chart1Scroll(Sender: TObject);
begin
  Scrolled := True;
end;

procedure TStatistikForm.FormCreate(Sender: TObject);
begin
  Scrolled := False;
  Zoomed := False;
end;

procedure TStatistikForm.Chart1Zoom(Sender: TObject);
begin
  Zoomed := True;
end;

procedure TStatistikForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose := False;
end;

end.
