unit cardfkt;

interface

uses graphics, windows;

  procedure _CardInit(var w,h: integer);
  procedure _CardDone;
  procedure _CardDraw(ACanvas: TCanvas; x,y: SmallInt; CardNo: SmallInt);
  procedure _CardDrawInverted(ACanvas: TCanvas; x,y: SmallInt; CardNo: SmallInt);
  procedure _BackDraw(ACanvas: TCanvas; x,y: SmallInt; BackNo: SmallInt);
  procedure _CardDrawExt(ACanvas: TCanvas; x,y: SmallInt; w,h: SmallInt; CardNo: SmallInt);

  var CardWidth, CardHeight: integer;


implementation

const dllFName='cards32.dll';

type pinteger=^integer;

procedure ehCardInit(pw,ph: pInteger); stdcall;
 external dllFName name 'cdtInit';

procedure ehCardDone; stdcall;
 external dllFName name 'cdtTerm';

procedure ehCardDraw(Hnd: THandle; destX,destY,cardno,mode: integer;
                     rgbBgnd: longint); stdcall;
 external dllFName name 'cdtDraw';

procedure ehCardDrawExt(Hnd: THandle; destX,destY,w,h: integer; cardno,mode: integer;
                     rgbBgnd: longint); stdcall;
 external dllFName name 'cdtDrawExt';



procedure _CardInit(var w,h: integer);
var pw,ph: pinteger;
begin
  pw:=new(pinteger);
  ph:=new(pinteger);
  ehCardInit(pw,ph);
  w:=pw^; h:=ph^;
end;

procedure _CardDone;
begin
  ehCardDone
end;

procedure _CardDraw(ACanvas: TCanvas; x,y: SmallInt; CardNo: SmallInt);
begin
  ehCardDraw(ACanvas.Handle,x,y,CardNo,0,0{ColorToRGB(ACanvas.Brush.Color)});
end;

procedure _CardDrawInverted(ACanvas: TCanvas; x,y: SmallInt; CardNo: SmallInt);
begin
  ehCardDraw(ACanvas.Handle,x,y,CardNo,2,clWhite);
end;

procedure _BackDraw(ACanvas: TCanvas; x,y: SmallInt; BackNo: SmallInt);
begin
  ehCardDraw(ACanvas.Handle,x,y,BackNo+54,1,0{ColorToRGB(ACanvas.Brush.Color)});
end;

procedure _CardDrawExt(ACanvas: TCanvas; x,y: SmallInt; w,h: SmallInt; CardNo: SmallInt);
begin
  ehCardDrawExt(ACanvas.Handle,x,y,w,h,CardNo,0,0);
end;

initialization

  _CardInit(CardWidth,CardHeight);

finalization

  _CardDone;

end.
