unit eventu;

interface

uses MainUnit, CardClasses, gui, eventu2, Bundeeventu;

  procedure ProgInit;
  procedure NewGame;
  procedure ValgtKortNil;
  procedure MouseDown(Pile: TPile; Card: TCard);
  procedure MouseUp(Pile: TPile; Card: TCard);
  procedure FindKort(S: Char; V: Integer);
  procedure BrugKort(S: Char; V: Integer);


implementation

uses dialogs,sysutils;

type TSelection=class
                  private
                    MyPile: TPile;
                    MyCard: TCard;
                  public
                    constructor Create;
                    procedure SetPileAndCard(aPile: TPile; aCard: TCard);
                    function GetPile: TPile;
                    function GetCard: TCard;
                    procedure Clear;
                end;


var spar, klor, ruder, hjerter : TPile;
    Selection: TSelection;
    ValgtKort : TCard;

const
    KortAfstand : Integer = 21;

constructor TSelection.Create;
begin
  MyPile:=nil; MyCard:=nil;
end;

procedure TSelection.SetPileAndCard(aPile: TPile; aCard: TCard);
begin
  MyPile:=aPile;
  MyCard:=aCard;
end;

function  TSelection.GetPile: TPile;
begin
  Result:=MyPile;
end;

function  TSelection.GetCard: TCard;
begin
  Result:=MyCard;
end;

procedure TSelection.Clear;
begin
  MyPile:=nil; MyCard:=nil;
end;

procedure ProgInit;
{ Kaldes ved programstart;
  skriv evt. initialiseringer ved programstart i denne procedure }
begin
  FrmBord.ClientWidth := KortAfstand * 12 + 77;
end;

procedure NewGame;
{ Kaldes ved start af nyt spil;
  skriv evt. initialiseringer ved start af nyt spil;
  HUSK frst at kalde free for alle skabte objekter fra
  evt. tidligere spil  }
var
  i : Integer;
begin
  Selection:=TSelection.create;
  CTable.clear;
  spar := TPile.Create(3, 3, KortAfstand, 0);
  klor := TPile.Create(3, 103, KortAfstand, 0);
  ruder := TPile.Create(3, 203, KortAfstand, 0);
  hjerter := TPile.Create(3, 303, KortAfstand, 0);
  spar.make52(True);
  for i := 39 to 51 do
    klor.insertAtBottom(spar.removeTopCard);
  for i := 26 to 38 do
    ruder.insertAtBottom(spar.removeTopCard);
  for i := 13 to 25 do
    hjerter.insertAtBottom(spar.removeTopCard);
  spar.insertAtTop(spar.removeBottomCard);
  klor.insertAtTop(klor.removeBottomCard);
  ruder.insertAtTop(ruder.removeBottomCard);
  hjerter.insertAtTop(hjerter.removeBottomCard);
  CTable.addPile(spar);
  CTable.addPile(klor);
  CTable.addPile(ruder);
  CTable.addPile(hjerter);
end;

procedure ValgtKortNil;
begin
  ValgtKort := nil;
end;

procedure MouseDown(Pile: TPile; Card: TCard);
{ kaldes ved MouseDown i bunken Pile p kortet Card;
  skriv kode der skal udfres ved MouseDown }
var
  x : Char;
begin
  if (not SpilIGang) or (Card = nil) then Exit;
  if (not Card.isSelected) and (Card.getCardNr <> -1) then
  begin
    Pile.flipCard(Card);
    if not KortFraBunke then Card.select;
    if KortFraBunke then ValgtKort := nil else ValgtKort := Card;
    Vaerdi := Card.GetValue;
    if Vaerdi = 1 then Vaerdi := 14;
    inc(KortBrugt);
    IndsaetVaerdi(Vaerdi);
    inc(Spiller);
    if (Spiller > AntalSpillere) and (KortBrugt < 52) then
    begin
      Spiller := 1;
      inc(Runde);
    end;
    case Card.getSuit of
      SPADE : x := 's';
      CLUB : x := 'k';
      DIAMOND : x := 'r';
      HEART : x := 'h';
    end;
    if not KortFraBunke then FjernKort(x, Card.getValue);
    if Vaerdi = 14 then FlytEs(x, Card.getValue);
  end else
  if Card.isSelected and (not KortFraBunke) then
  begin
    if ValgtKort = Card then
    begin
      FortrydFjern;
      KortFortrudt := True;
      Pile.flipCard(Card);
      Card.deselect;
      dec(KortBrugt);
      dec(Spiller);
      if Spiller < 1 then
      begin
        Spiller := AntalSpillere;
        dec(Runde);
      end;
      case Card.getSuit of
        SPADE : x := 's';
        CLUB : x := 'k';
        DIAMOND : x := 'r';
        HEART : x := 'h';
      end;
    if Vaerdi = 14 then FortrydEs(x, Card.getValue);
    IndsaetVaerdi(Vaerdi * -1);
    end;
  end;
  KortFraBunke := False;
  KortFortrudt := False;
  if KortBrugt = 52 then SpilSlut;
end;

procedure MouseUp(Pile: TPile; Card: TCard);
{ kaldes ved MouseUp i bunken Pile p kortet Card;
  skriv kode der skal udfres ved MouseUp }
begin
// MouseUp procedure
end;


procedure FindKort(S: Char; V: Integer);
begin
  KortFraBunke := True;
  case S of
  's' :
    begin
      ValgtKort := spar.Find(SPADE, V);
      eventu.MouseDown(spar,ValgtKort);
    end;
  'k' :
    begin
      ValgtKort := klor.Find(CLUB, V);
      eventu.MouseDown(klor,ValgtKort);
    end;
  'r' :
    begin
      ValgtKort := ruder.Find(DIAMOND, V);
      eventu.MouseDown(ruder,ValgtKort);
    end;
  'h' :
    begin
      ValgtKort := hjerter.Find(HEART, V);
      eventu.MouseDown(hjerter,ValgtKort);
    end;
  else KortFraBunke := False;
  end;
end;

procedure BrugKort(S: Char; V: Integer);
var
  Card : TCard;
begin
  case S of
  's' :
    begin
      Card := spar.Find(SPADE, V);
      eventu.MouseDown(spar,Card);
    end;
  'k' :
    begin
      Card := klor.Find(CLUB, V);
      eventu.MouseDown(klor,Card);
    end;
  'r' :
    begin
      Card := ruder.Find(DIAMOND, V);
      eventu.MouseDown(ruder,Card);
    end;
  'h' :
    begin
      Card := hjerter.Find(HEART, V);
      eventu.MouseDown(hjerter,Card);
    end;
  end;
end;

end.
