unit eventu2;

interface

uses MainUnit, CardClasses2, gui2;

  procedure ProgInit;
  procedure NewGame;
  procedure MouseDown(Pile: TPile; Card: TCard);
  procedure MouseUp(Pile: TPile; Card: TCard);
  procedure FjernKort(S: Char; V: Integer);
  procedure FortrydFjern();
  function HentFarve(Nr: Integer): String;
  function HentNr(Nr: Integer): String;


implementation

uses dialogs,sysutils, eventu;

type TSelection=class
                  private
                    MyPile: TPile;
                    MyCard: TCard;
                  public
                    constructor Create;
                    procedure SetPileAndCard(aPile: TPile; aCard: TCard);
                    function GetPile: TPile;
                    function GetCard: TCard;
                    procedure Clear;
                end;


var bund, vendt: TPile;
    Selection: TSelection;
    FjernetKort : TCard;
    FjernHvor: Integer;

constructor TSelection.Create;
begin
  MyPile:=nil; MyCard:=nil;
end;

procedure TSelection.SetPileAndCard(aPile: TPile; aCard: TCard);
begin
  MyPile:=aPile;
  MyCard:=aCard;
end;

function  TSelection.GetPile: TPile;
begin
  Result:=MyPile;
end;

function  TSelection.GetCard: TCard;
begin
  Result:=MyCard;
end;

procedure TSelection.Clear;
begin
  MyPile:=nil; MyCard:=nil;
end;

procedure ProgInit;
{ Kaldes ved programstart;
  skriv evt. initialiseringer ved programstart i denne procedure }
begin
  NewGame;
end;

procedure NewGame;
{ Kaldes ved start af nyt spil;
  skriv evt. initialiseringer ved start af nyt spil;
  HUSK frst at kalde free for alle skabte objekter fra
  evt. tidligere spil  }
begin
  Selection:=TSelection.create;
  CTable.clear;
  bund := TPile.Create(3,3,0,0);
  vendt := TPile.Create(80,3,0,0);
  bund.make52(False);
  bund.Shuffle;
  CTable.addPile(bund);
  CTable.addPile(vendt);
end;

procedure MouseDown(Pile: TPile; Card: TCard);
{ kaldes ved MouseDown i bunken Pile p kortet Card;
  skriv kode der skal udfres ved MouseDown }
//  var pFra: TPile; ok: boolean;
begin
  if not SpilIGang then Exit;
  if (Card<>nil) and (Pile = bund) then
  begin
    Pile.flipCard(Card);
    vendt.insertAtTop(bund.removeTopCard);
    case Card.getSuit of
    SPADE :
      begin
        FindKort('s', Card.getValue);
      end;
    CLUB :
      begin
        FindKort('k', Card.getValue);
      end;
    DIAMOND :
      begin
        FindKort('r', Card.getValue);
      end;
    HEART :
      begin
        FindKort('h', Card.getValue);
      end;
    end;
  end;
end;

procedure MouseUp(Pile: TPile; Card: TCard);
{ kaldes ved MouseUp i bunken Pile p kortet Card;
  skriv kode der skal udfres ved MouseUp }
begin
// MouseUp procedure
end;

procedure FjernKort(S: Char; V: Integer);
begin
  case S of
  's' :
      FjernetKort := bund.Find(SPADE, V);
  'k' :
      FjernetKort := bund.Find(CLUB, V);
  'r' :
      FjernetKort := bund.Find(DIAMOND, V);
  'h' :
      FjernetKort := bund.Find(HEART, V);
  end;
  FjernHvor := bund.getIndex(FjernetKort);
  vendt.insertAtTop(bund.getCardAt(FjernHvor));
  vendt.flipTop;
  bund.removeCard(FjernetKort);
end;

procedure FortrydFjern();
begin
  if FjernHvor = bund.getSize then bund.insertAtTop(FjernetKort)
  else bund.insertAt(FjernHvor, FjernetKort);
  vendt.removeTopCard;
  bund.flipCard(FjernetKort);
end;

function HentFarve(Nr: Integer): String;
var
  Card : TCard;
begin
  Card := vendt.getCardAt(Nr - 1);
    case Card.getSuit of
    SPADE :
      Result := 's';
    CLUB :
      Result := 'k';
    DIAMOND :
      Result := 'r';
    HEART :
      Result := 'h';
    end;
end;

function HentNr(Nr: Integer): String;
var
  Card : TCard;
begin
  Card := vendt.getCardAt(Nr - 1);
  Result := IntToStr(Card.getValue);
end;

end.
