unit gui2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus;

type
  TFrmBord2 = class(TForm)
    procedure FormPaint(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
     procedure EraseRect(HFillrect,VFillRect: TRect);
     procedure DrawEmptyPile(aType: integer;x1,y1: integer);
     procedure CardDrawInverted(x,y,CardNr: integer);
     procedure CardDraw(x,y,CardNr: integer);
     procedure BackDraw(x,y,BackNr: integer);
  end;

var
  FrmBord2: TFrmBord2;

implementation

{$R *.DFM}

uses cardclasses2, cardFkt, Eventu2;

procedure TFrmBord2.EraseRect(HFillrect,VFillRect: TRect);
begin
  Canvas.brush.Color:=Color;
  Canvas.FillRect(HFillRect);
  Canvas.FillRect(VFillRect);
end;

procedure TFrmBord2.DrawEmptyPile(aType: integer;x1,y1: integer);
const d=5;
var i: integer;
begin
  case aType of
    1: _BackDraw(Canvas,x1,y1,14);
    2: _BackDraw(Canvas,x1,y1,13);
    else
      Canvas.Pen.Color:=clLime;
      for i:=0 to 1 do
        Canvas.RoundRect(x1+i,y1+i,x1+CardWidth-i,y1+CardHeight-i,d,d);
  end
end;

procedure TFrmBord2.CardDrawInverted(x,y,CardNr: integer);
begin
  _CardDrawInverted(FrmBord2.Canvas,x,y,CardNr);
end;

procedure TFrmBord2.CardDraw(x,y,CardNr: integer);
begin
  _CardDraw(FrmBord2.Canvas,x,y,CardNr);
end;

procedure TFrmBord2.BackDraw(x,y,BackNr: integer);
begin
  _BackDraw(FrmBord2.Canvas,x,y,BackNr);
end;

procedure TFrmBord2.FormPaint(Sender: TObject);
begin
  CTable.Refresh;
end;

procedure TFrmBord2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//  CTable.Clear;
end;

procedure TFrmBord2.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var p: TPile; c: TCard;
begin
  if Button <> mbLeft then Exit;
  CTable.GetPileCardAt(x,y,p,c);
  if p<>nil then eventu2.MouseDown(p,c);
end;

procedure TFrmBord2.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var p: TPile; c: TCard;
begin
  if Button <> mbLeft then Exit;
  CTable.GetPileCardAt(x,y,p,c);
  if p<>nil then eventu2.MouseUp(p,c);
end;

procedure TFrmBord2.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := False;
end;

end.
